// www.sunandshadows.com
// v1.0

$missionName = "Dark Night of the Soul";
exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
$server::HudMapViewOffsetX = -6000;
$server::HudMapViewOffsetY = 3000;

function setDefaultMissionOptions(){
 $server::TeamPlay = false;
 $server::AllowDeathmatch = true;
 $server::AllowTeamPlay = true;
 $server::AllowTeamRed = true;
 $server::AllowTeamBlue = true;
 $server::AllowTeamYellow = true;
 $server::AllowTeamPurple = true; }

function onMissionLoad(){ cdAudioCycle("SS3", "SS4", "SS3"); }

function cybridplanetSounds(){
 meteorSounds();
 %weather1 = getObjectId("MissionGroup\\World\\sky");
 createAmbientSoundSource(%weather1, 0, 10, 12);
 addToAmbientSoundSource(%weather1, "sfx_cybrid_indust.wav", IDPRF_2D); }

function onMissionStart(){
 order("MissionGroup/ai/ai", guard, "MissionGroup/ai/path");
 order("MissionGroup/ai/ai", cloak, true);
 $turret = *IDSTR_TEAM_YELLOW;
 scrollTurret();
 cybridPlanetSounds(); }

function redact::trigger::onEnter(%t, %v){
 if(randomInt(0,10) == 0){ say(0,0,getHudName(%v)@" is being carefully observed by Redactor Sect."); }
 if(randomInt(0,10) == 1){
  say(0,0,getHudName(%v)@" has been redacted.");
  damageObject(%v, 100000); } }

function randomDrop(%this){
 %player = playerManager::vehicleIdToPlayerNum(%this);
 fadeEvent(%player, in, 20, 3, 3, 3 );
 setPosition(%this, 2000, 2000, 8000);
 %endX = randomInt(-5000, -7000);
 %endY = randomInt(2000, 3000);
 %endZ = getTerrainHeight(%endX, %endY);
 dropPod(2000, 2000, 800, %endX, %endY, %endZ, %this); }

function smoothmoveeinstein::trigger::onContact(%t, %v){ damageObject(%v, 1000); }

function turret::onAttacked(%t){ healObject(%t, 100000); }

function scrollTurret(){
 setTeam(8417, $turret);
 if($turret == *IDSTR_TEAM_YELLOW){ $turret = *IDSTR_TEAM_BLUE; }
 else if($turret == *IDSTR_TEAM_BLUE){ $turret = *IDSTR_TEAM_RED; }
 else if($turret == *IDSTR_TEAM_RED){ $turret = *IDSTR_TEAM_PURPLE; }
 else if($turret == *IDSTR_TEAM_PURPLE){ $turret = *IDSTR_TEAM_YELLOW; }
 schedule("scrollTurret();", 60); }

function activate::structure::onScan(%t, %v){ setTeam(8417, getTeam(%v)); }

function jammer::structure::onScan(%t, %v){
 %p = playerManager::vehicleIdToPlayerNum(%v);
 if(getTeam(%t) == getTeam(%v) && %v.tag != true){
  %v.tag = true;
  setVehicleRadarVisible(%v, false);
  say(%p,1234,"Jamming engaged.", "cy_Jam_engaged.WAV"); }
 else if(getTeam(%t) == getTeam(%v) && %v.tag == true){
  %v.tag = false;
  setVehicleRadarVisible(%v, true);
  say(%p,1234,"Jamming disabled.", "cy_Jam_disabled.WAV"); } }

function jammer::structure::onDestroyed(%t, %v){
 setVehicleRadarVisible(getTeam(%t), true);
 setVehicleRadarVisible(%v, false);
 say(0,1234,getTeam(%t)@" Jamming disabled.","cy_Jam_disabled.WAV"); }

function boom::structure::onDestroyed(%t){ damageArea(%t,0,0,0,200,2000); }

function relay::structure::onScan(%t){  playSound(0, "sfx_cybrid_indust.wav", IDPRF_FIRE, %t); }

function bigboom::structure::onDestroyed(%t){ damageArea(%t,0,0,0,300,3000); }

function bolo::vehicle::onadd(%v){
 %player = playermanager::vehicleIdtoPlayerNum(%v);
 if(%player != 0){
  damageobject(%v, 1000000);
  say(0,0,"<F5>Player "@getName(%player)@" attempted to spawn in a scripted vehicle!");
  return; } }

function bolo::vehicle::onDestroyed(%t){ damageArea(%t,0,0,0,200,3000); }

$killPoints = 2;
$deathPoints = 3;
$server::teamdamage = true;

function setRules(){
 if($server::TeamPlay == true){
  %rules = "<F5>Mission: <F2>S&S <F2>Dark Night of the Soul<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>'Stolen Soul' by Timeless.\n" @
           "<F5>Setting: <F0>Cybrid installation, Charon. 23 July 2831.\n" @
           "<F5>Story: <F0>A Cybrid base exhibits heretical influences, attracting the attention of Redactor Sect. " @
           "A force is dispatched to reclaim the base for Giver-of-Will.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Team Deathmatch: <F0>Kill opposing team.  Protect your teammates.  Defend your base and destroy opposing bases. Use map features to your advantage.\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Droppods: <F0>Human vehicles drop in pods instead of bases.\n" @
           "<F5>Redaction: <F0>Pads have 10% chance of recycling a player.\n" @
           "<F5>Unstable Terrain: <F0>Weak spots in ice can cave in and trap vehicles.\n" @
           "<F5>Jammers: <F0>Team jammer units make you radar invisible when scanned, unless destroyed.\n" @
           "<F5>Bolos: <F0>Highly dangerous Exemplar units circle the map.\n" @
           "<F5>Dropship: <F0>Dropship fires on heretical units."; }
 else{
  %rules = "<F5>Mission: <F2>S&S <F2>Dark Night of the Soul<F0>.\n" @
           "<F5>Created by: <F2>Velax <F0>and <F2>www.SunAndShadows.com<F0> for AK servers.\n" @
           "<F5>Inspired by: <F0>'Stolen Soul' by Timeless.\n" @
           "<F5>Setting: <F0>Cybrid installation, Charon. 23 July 2831.\n" @
           "<F5>Story: <F0>A Cybrid base exhibits heretical influences, attracting the attention of Redactor Sect. " @
           "A force is dispatched to reclaim the base for Giver-of-Will.\n" @
           "<F2>General map conditions:\n" @
           "<F5>Deathmatch: <F0>If it moves, kill it.  If it doesn't, kill it anyway..\n" @
           "<F2>Special map conditions:\n" @
           "<F5>Human Droppods: <F0>Human vehicles drop at pods rather than at bases.\n" @
           "<F5>Redaction Stations: <F0>Pads have 10% chance of recycling a player.\n" @
           "<F5>Unstable Terrain: <F0>Weak spots in ice can cave in and trap vehicles.\n" @
           "<F5>Bolos: <F0>Highly dangerous Exemplar units circle the map.\n" @
           "<F5>Dropship: <F0>Dropship fires on heretical units."; }
 setGameInfo(%rules); }

setRules();

function round(%n){
 %roundNum = %n;
 if(%n > 0){
  %excess = (%n - floor(%n));
  if(%excess >= 0.5){ %roundNum = (floor(%n) + 1); }
  else{ %roundNum = floor(%n); } }
 else if(%n < 0){
  %excess = (floor(%n) - %n);
  if(%excess <= 0.5){ %roundNum = floor(%n); }
  else{ %roundNum = (floor(%n) - 1); } }
 return %roundNum; }

function player::onAdd(%player){
 if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/")){
  say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
  messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence."); }
 say(%player, 0, "Welcome to S&S "@$missionname@" created by Velax.  Please read the rules carefully. Visit www.Sun and Shadows.com, your Starsiege community headquarters!"); }

function vehicle::onAdd(%this){
 if(getVehicleTechBase(%this) == "H"){ randomDrop(%this); }
 if($server::TeamPlay != true){
  %player = playerManager::vehicleIdToPlayerNum(%this);
  if(%player == 0){ return; }
  setTeam(%this, *IDSTR_TEAM_YELLOW); }
 %player.hitstaken = 0;
 %player.hitsdealt = 0; }

function vehicle::onattacked(%v, %w){
 %player = playerManager::vehicleIdToPlayerNum(%v);
 %player2 = playerManager::vehicleIdToPlayerNum(%w);
 if(%player == %player2){ return; }
 if((getTeam(%player) == getTeam(%player2)) && ($server::teamplay == true)){ return; }
 %player.hitstaken++;
 %player2.hitsdealt++; }

function getPlayerScore(%a){ return((getKills(%a) * $killPoints) - (getDeaths(%a) * $deathPoints) + (%a.hitstaken / 50) + (%a.hitsdealt / 25)); }

function getTeamScore(%a){ return((getTeamKills(%a) * $killPoints) - (getTeamDeaths(%a) * $deathPoints)); }

function getHitsTaken(%a){ return(%a.hitsTaken); }

function getHitsDealt(%a){ return(%a.hitsDealt); }

function initScoreBoard(){
 deleteVariables("$ScoreBoard::PlayerColumn*");
 deleteVariables("$ScoreBoard::TeamColumn*");
 if($server::TeamPlay == "True"){
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt";
  $ScoreBoard::PlayerColumnFunction7 = "getSquad"; }
 else{
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
  $ScoreBoard::PlayerColumnHeader2 = "Score";
  $ScoreBoard::PlayerColumnHeader3 = "Hits Taken";
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;
  $ScoreBoard::PlayerColumnHeader6 = "Hits Dealt";
  $ScoreBoard::PlayerColumnFunction1 = "getSquad";
  $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction3 = "getHitsTaken";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";
  $ScoreBoard::PlayerColumnFunction6 = "getHitsDealt"; }
 $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
 $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
 $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
 $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;
 $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
 $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
 $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
 $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";
 serverInitScoreBoard(); }

//
